import .connectives
import .leibniz
import .logic
axiom nat.nat : Type.
constant nat.O : nat.nat.
constant nat.S : (nat.nat) -> nat.nat.
constant nat.match_nat_type : forall (return : Type) , (return) -> ((nat.nat) -> return) -> (nat.nat) -> return.
axiom nat.axiom_match_nat_type_S : forall (return_type : Type) , forall (case_O:return_type) , forall (case_S:(nat.nat) -> return_type) , forall (n:nat.nat) , (((connectives.equal) (return_type)) (((((nat.match_nat_type) (return_type)) (case_O)) (case_S)) (((nat.S) ) (n)))) ((case_S) (n)).
theorem nat.eq_match_nat_type_S : forall (return_type : Type) , forall (case_O:return_type) , forall (case_S:(nat.nat) -> return_type) , forall (n:nat.nat) , (((leibniz.leibniz) (return_type)) (((((nat.match_nat_type) (return_type)) (case_O)) (case_S)) (((nat.S) ) (n)))) ((case_S) (n)) := fun (return_type : Type) , fun (case_O : return_type) , fun (case_S : (nat.nat) -> return_type) , fun (n : nat.nat) , ((((@connectives.equal_leibniz) (return_type)) (((((nat.match_nat_type) (return_type)) (case_O)) (case_S)) (((nat.S) ) (n)))) ((case_S) (n))) (((((@nat.axiom_match_nat_type_S) (return_type)) (case_O)) (case_S)) (n)).
theorem nat.sym_eq_match_nat_type_S : forall (return_type : Type) , forall (case_O:return_type) , forall (case_S:(nat.nat) -> return_type) , forall (n:nat.nat) , (((leibniz.leibniz) (return_type)) ((case_S) (n))) (((((nat.match_nat_type) (return_type)) (case_O)) (case_S)) (((nat.S) ) (n))) := fun (return_type : Type) , fun (case_O : return_type) , fun (case_S : (nat.nat) -> return_type) , fun (n : nat.nat) , ((((@leibniz.sym_leibniz) (return_type)) (((((nat.match_nat_type) (return_type)) (case_O)) (case_S)) (((nat.S) ) (n)))) ((case_S) (n))) (((((@nat.eq_match_nat_type_S) (return_type)) (case_O)) (case_S)) (n)).
noncomputable def nat.pred_ : (nat.nat) -> nat.nat := fun (n : nat.nat) , ((((nat.match_nat_type) (nat.nat)) ((nat.O) )) (fun (p : nat.nat) , p)) (n).
constant nat.le_ : (nat.nat) -> (nat.nat) -> Prop.
axiom nat.match_le_prop : forall (n:nat.nat) , forall (return:(nat.nat) -> Prop) , ((return) (n)) -> (forall (m:nat.nat) , (return) (((nat.S) ) (m))) -> forall (m:nat.nat) , ((((nat.le_) ) (n)) (m)) -> (return) (m).
def nat.lt_ : (nat.nat) -> (nat.nat) -> Prop := fun (n : nat.nat) , fun (m : nat.nat) , (((nat.le_) ) (((nat.S) ) (n))) (m).
theorem nat.pred_Sn : forall (n:nat.nat) , (((logic.eq_) (nat.nat)) (n)) (((nat.pred_) ) (((nat.S) ) (n))) := fun (n : nat.nat) , ((((((@nat.sym_eq_match_nat_type_S) (nat.nat)) ((nat.O) )) (fun (p : nat.nat) , p)) (n)) (fun (y : nat.nat) , (((logic.eq_) (nat.nat)) (n)) (y))) (((@logic.refl_) (nat.nat)) (n)).
theorem nat.S_pred : forall (n:nat.nat) , ((((nat.lt_) ) ((nat.O) )) (n)) -> (((logic.eq_) (nat.nat)) (((nat.S) ) (((nat.pred_) ) (n)))) (n) := fun (n : nat.nat) , fun (posn : (((nat.lt_) ) ((nat.O) )) (n)) , (((((((@nat.match_le_prop) (((nat.S) ) ((nat.O) ))) (fun (__ : nat.nat) , (((logic.eq_) (nat.nat)) (((nat.S) ) (((nat.pred_) ) (__)))) (__))) (((((((@logic.rewrite_l) (nat.nat)) ((nat.O) )) (fun (__ : nat.nat) , (((logic.eq_) (nat.nat)) (((nat.S) ) (__))) (((nat.S) ) ((nat.O) )))) (((@logic.refl_) (nat.nat)) (((nat.S) ) ((nat.O) )))) (((nat.pred_) ) (((nat.S) ) ((nat.O) )))) ((@nat.pred_Sn) ((nat.O) )))) (fun (m : nat.nat) , ((((((@logic.rewrite_l) (nat.nat)) (m)) (fun (__ : nat.nat) , (((logic.eq_) (nat.nat)) (((nat.S) ) (__))) (((nat.S) ) (m)))) (((@logic.refl_) (nat.nat)) (((nat.S) ) (m)))) (((nat.pred_) ) (((nat.S) ) (m)))) ((@nat.pred_Sn) (m)))) (n)) (posn)).
